% Natali Ruchansky
% Boston University Computer Science

%%Prepare Variables for Non-negative least squares

% Given Z and S, construct A b and for the nnls formulation according to
% Equation 6 in the paper, but with two signs flipped
% this can be re-written as Ax=b where
    %b(i)=Z(i,j)*sum(S(i,:))
    %A=A2-A1
        %A1(i,:)=Z(i,j)
        %A2(i,k)=(1+Z(i,j))*S(i,k)

function [ A, b, curDists] = nnlsVar( Z,S,cur )

n=length(Z);  
b=zeros(n,1);
k=size(S,2);
curDists=Z(:,cur);

%Create b
for i=1:n
    sSums(i,1)=nnz(S(i,:));
end
b=curDists.*sSums;

%Create A
A=bsxfun(@times, curDists,S);
A=bsxfun(@plus, A,S);
A=bsxfun(@minus,A, curDists);


%%%%%Alternate Method%%%%%%
% %Create b
% for i=1:n
%     sSums(i,1)=sum(S(i,:));
% end
% b=curDists.*sSums;
% 
% %Create A1
% for i=1:k
%     A1(:,i)=curRsds;
% end
% 
% %Create A2
% A2=A1+1;
% A2=A2.*S;
% 
% %Create A
% A=A2-A1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%

end

