% Natali Ruchansky
% Boston University Computer Science

% Inputs:
%Z: z(i,j) distance between i and j
%S: S(i,:) represents which clusters i belongs to
%p: the max number of clusters a prefix can participate in

%Output:
%S: S(i,:) is the resulting cluster membership for prefix i

function [ newS, costs ] = overlapClusters( S, Z ,p)


n=length(Z);

%Keep track of the cost of current and previous iterations
%to decide whether to continue
CoccPrev=Inf;
CoccCur=500000000000;
Cup=zeros(1,n);

newS=S;
k=size(S,2); %number of initial clusters
o=1;


%While the cost decreases
while CoccPrev>CoccCur
    %For each element
    for i=1:n
        %Construct A and b using Z and S
        [A b Xrsds]=nnlsVar(Z,newS,i);
        %find the optimal labeling using local search (NNLS)
        X=lsqnonneg(A,b);
        %optimize/disceretize
        [newX,C]=greedypp(newS,Z,X,p,i, Xrsds);
        %update S and Cup
        Cup(i)=C;
        newS(i,:)=newX;
        save temprsdClust newS Cup i -v7.3
    end
    
    costs(o)=CoccCur
    o=o+1
%     save rsdClust newS costs
    CoccPrev=CoccCur;
    CoccCur=compClustCost(Cup);
end

end